b9b105f744146579d36a06ddff480c735057ea11
[debian/amanda] / server-src / amdump.sh
1 #!@SHELL@
2 #
3 # Amanda, The Advanced Maryland Automatic Network Disk Archiver
4 # Copyright (c) 1991-1998 University of Maryland at College Park
5 # All Rights Reserved.
6 #
7 # Permission to use, copy, modify, distribute, and sell this software and its
8 # documentation for any purpose is hereby granted without fee, provided that
9 # the above copyright notice appear in all copies and that both that
10 # copyright notice and this permission notice appear in supporting
11 # documentation, and that the name of U.M. not be used in advertising or
12 # publicity pertaining to distribution of the software without specific,
13 # written prior permission.  U.M. makes no representations about the
14 # suitability of this software for any purpose.  It is provided "as is"
15 # without express or implied warranty.
16 #
17 # U.M. DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
18 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL U.M.
19 # BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
20 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
21 # OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
22 # CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
23 #
24 # Author: James da Silva, Systems Design and Analysis Group
25 #                          Computer Science Department
26 #                          University of Maryland at College Park
27 #
28
29 #
30 # amdump: Manage running one night's Amanda dump run.
31 #
32
33 prefix="@prefix@"
34 exec_prefix="@exec_prefix@"
35 sbindir="@sbindir@"
36 amlibexecdir="@amlibexecdir@"
37 . "${amlibexecdir}/amanda-sh-lib.sh"
38
39 confdir=@CONFIG_DIR@
40
41 # add sbin and ucb dirs
42 PATH="$PATH:/usr/sbin:/sbin:/usr/ucb"
43 export PATH
44
45 USE_VERSION_SUFFIXES="@USE_VERSION_SUFFIXES@"
46 if test "$USE_VERSION_SUFFIXES" = "yes"; then
47         SUF="-@VERSION@"
48 else
49         SUF=
50 fi
51
52 if [ $# -lt 1 ]
53 then
54         echo `_ 'Usage: %s config [host [disk...]...]' "$0"`  1>&2
55         exit 1
56 fi
57
58 exit_status=0;
59
60 conf=$1
61 if [ ! -d $confdir/$conf ]; then
62     echo `_ '%s: could not find directory %s' "amdump$SUF" "$confdir/$conf"` 1>&2
63     exit 1
64 fi
65 shift
66
67 cd $confdir/$conf || exit 1
68
69 logdir=`amgetconf$SUF $conf logdir "$@"`
70 [ $? -ne 0 ]  && exit 1
71 errfile=$logdir/amdump
72 tapecycle=`amgetconf$SUF $conf tapecycle "$@"`
73 [ $? -ne 0 ]  && exit 1
74 dumpuser=`amgetconf$SUF $conf dumpuser "$@"`
75 [ $? -ne 0 ]  && exit 1
76
77 runuser=`{ whoami ; } 2>/dev/null`
78 if [ $? -ne 0 ]; then
79         idinfo=`{ id ; } 2>/dev/null`
80         if [ $? -ne 0 ]; then
81                 runuser=${LOGNAME:-"??unknown??"}
82         else
83                 runuser=`echo $idinfo | sed -e 's/).*//' -e 's/^.*(//'`
84         fi
85 fi
86
87 if [ $runuser != $dumpuser ]; then
88         echo `_ '%s: must be run as user %s, not %s' "$0" "$dumpuser" "$runuser"` 1>&2
89         exit 1
90 fi
91
92 if test -f hold; then
93         echo `_ '%s: waiting for hold file to be removed' "$0"` 1>&2
94         while test -f hold; do
95                 sleep 60
96         done
97 fi
98
99 if test -f $errfile || test -f $logdir/log; then
100         amcleanup$SUF -p $conf
101 fi
102
103 gdate=`date +'%a %b %e %H:%M:%S %Z %YAAAAA%Y%m%dBBBBB%Y%m%d%H%M%SCCCCC%Y-%m-%d %H:%M:%S %Z'`
104
105 #date=%a %b %e %H:%M:%S %Z %Y
106 date=`echo $gdate |sed -e "s/AAAAA.*$//"`
107
108 #date_datestamp="%Y%m%d"
109 date_datestamp=`echo $gdate |sed -e "s/^.*AAAAA//;s/BBBBB.*$//"`
110
111 #date_starttime="%Y%m%d%H%M%S"
112 date_starttime=`echo $gdate |sed -e "s/^.*BBBBB//;s/CCCCC.*$//"`
113
114 #date_locale_independent=%Y-%m-%d %H:%M:%S %Z
115 date_locale_independent=`echo $gdate |sed -e "s/^.*CCCCC//"`
116
117 if test -f $errfile || test -f $logdir/log; then
118         process_name=`grep "^INFO .* .* pid " $logdir/log | head -n 1 | awk '{print $2}'`
119         echo `_ '%s: %s is already running, or you must run amcleanup' "$0" "${process_name}"` 1>&2
120         echo "INFO amdump amdump pid $$" > $logdir/log.$$
121         echo "START driver date $date_starttime" >> $logdir/log.$$
122         echo "ERROR amdump " `_ '%s is already running, or you must run amcleanup' "${process_name}"` >> $logdir/log.$$
123         $sbindir/amreport$SUF $conf -l $logdir/log.$$ "$@"
124         rm -f $logdir/log.$$
125         exit 1;
126 fi
127
128 umask 077
129
130 echo "INFO amdump amdump pid $$" > $logdir/log
131 exit_code=0
132 # Plan and drive the dumps.
133 #exec </dev/null >$errfile 2>&1
134 touch $errfile
135 exit_code=$?
136 [ $exit_code -ne 0 ] && exit_status=$exit_code
137 exec </dev/null 2>>$errfile 1>&2
138 exit_code=$?
139 [ $exit_code -ne 0 ] && exit_status=$exit_code
140
141 printf '%s: start at %s\n' "amdump" "$date"
142 printf '%s: datestamp %s\n' "amdump" "$date_datestamp"
143 printf '%s: starttime %s\n' "amdump" "$date_starttime"
144 printf '%s: starttime-locale-independent %s\n' "amdump" "$date_locale_independent"
145
146 # shells don't do well with handling exit values from pipelines, so we emulate
147 # a pipeline in perl, in such a way that we can combine both exit statuses in a
148 # kind of logical "OR".
149 @PERL@ - $amlibexecdir/planner$SUF $amlibexecdir/driver$SUF $conf $date_starttime "$@" <<'EOPERL'
150 use IPC::Open3;
151 use POSIX qw(WIFEXITED WEXITSTATUS);
152 my ($planner, $driver, $conf, $date_starttime, @args) = @ARGV;
153
154 open3("</dev/null", \*PIPE, ">&STDERR", $planner, $conf, '--starttime', $date_starttime, @args)
155     or die "Could not exec $planner: $!";
156 open3("<&PIPE", ">&STDOUT", ">&STDERR", $driver, $conf, @args)
157     or die "Could not exec $driver: $!";
158
159 my $first_bad_exit = 0;
160 for (my $i = 0; $i < 2; $i++) {
161     my $dead = wait();
162     die("Error waiting: $!") if ($dead <= 0);
163     my $exit = WIFEXITED($?)? WEXITSTATUS($?) : 1;
164     $first_bad_exit = $exit if ($exit && !$first_bad_exit)
165 }
166 exit $first_bad_exit;
167 EOPERL
168 exit_code=$?
169 [ $exit_code -ne 0 ] && exit_status=$exit_code
170 printf '%s: end at %s\n' "amdump" "`date`"
171
172 # Send out a report on the dumps.
173 $sbindir/amreport$SUF $conf "$@"
174 exit_code=$?
175 [ $exit_code -ne 0 ] && exit_status=$exit_code
176
177 # Roll the log file to its datestamped name.
178 $amlibexecdir/amlogroll$SUF $conf "$@"
179 exit_code=$?
180 [ $exit_code -ne 0 ] && exit_status=$exit_code
181
182 # Trim the log file to those for dumps that still exist.
183 $amlibexecdir/amtrmlog$SUF $conf "$@"
184 exit_code=$?
185 [ $exit_code -ne 0 ] && exit_status=$exit_code
186
187 # Trim the index file to those for dumps that still exist.
188 $amlibexecdir/amtrmidx$SUF $conf "$@"
189 exit_code=$?
190 [ $exit_code -ne 0 ] && exit_status=$exit_code
191
192 # Keep a debug log through the tapecycle plus a couple of days.
193 maxdays=`expr $tapecycle + 2`
194 days=1
195 # First, find out the last existing errfile,
196 # to avoid ``infinite'' loops if tapecycle is infinite
197 while [ $days -lt $maxdays ] && [ -f $errfile.$days ]; do
198         days=`expr $days + 1`
199 done
200 # Now, renumber the existing log files
201 while [ $days -ge 2 ]; do
202         ndays=`expr $days - 1`
203         mv $errfile.$ndays $errfile.$days
204         exit_code=$?
205         [ $exit_code -ne 0 ] && exit_status=$exit_code
206         days=$ndays
207 done
208 mv $errfile $errfile.1
209 exit_code=$?
210 [ $exit_code -ne 0 ] && exit_status=$exit_code
211
212 exit $exit_status